/***
	@author Derek Callaway <super@udel.edu> -- S@IRC
	@version 1.0
	@see http://www.low-level.net/super
	
	Bind to a random ipv4 address from the addr.list file and connect
	to the specified host.
*/

#include<stdio.h>
#include<stdlib.h>
#include<unistd.h>
#include<errno.h>
#include"randsrc.h"

/***
	@param argv c-style command-line arguments

	Print out a short usage message
*/

static void usage(char*argv[])
{
	fprintf(stderr,"usage: %s remote-addr remote-port\n",argv[0]);
	fprintf(stderr,"example: %s host.dom 80\n",argv[0]);
	exit(EXIT_FAILURE);
}
	
int main(int argc,char*argv[])
{
	int sock;
	fd_set rfds,efds;
	char buf[1024];
	unsigned int len;
	unsigned long port;

	if(argc<3)
		usage(argv);

	port=strtoul(argv[2],(char**)NULL,10);
	if(errno==ERANGE)
	{
		fprintf(stderr,"ERROR: Invalid port!\n");
		usage(argv);
	}

	sock=randsrc_tcpconnect(argv[1],(short)port);

	while(1)
	{
		FD_ZERO(&rfds);
		FD_ZERO(&efds);
		FD_SET(STDIN_FILENO,&rfds);
		FD_SET(STDIN_FILENO,&efds); 
		FD_SET(sock,&efds);
		FD_SET(sock,&rfds);

		if(select(sock+1,&rfds,NULL,&efds,NULL)<0)
			randsrc_vexit("select");

		if(FD_ISSET(STDIN_FILENO,&efds)||FD_ISSET(STDIN_FILENO,&rfds))
		{
			len=read(STDIN_FILENO,buf,sizeof(buf));
			buf[len]='\0';
			if(write(sock,buf,len)<=0)
				break;
		}
		if(FD_ISSET(sock,&rfds)||FD_ISSET(sock,&efds))
		{
			if((len=read(sock,buf,sizeof(buf)))<=0)
				break;
			buf[len]='\0';

			fputs(buf,stdout);
		}
	}

	exit(EXIT_SUCCESS);
}
