/***
	@author Derek Callaway <super@udel.edu> -- S@IRC
	@version 1.0
	@param host hostname to connect to (IPv4 or DNS address)
	@param port port to connect to on hostname
	@return connected socket
*/

#include<stdio.h>
#include<netinet/in.h>
#include<sys/socket.h>
#include<arpa/inet.h>
#include<netdb.h>
#include"randsrc.h"

int randsrc_tcpconnect(const char*host,const unsigned short port){
	char*line;
	struct hostent*hostinfo;
	struct sockaddr_in local,remote;
	struct in_addr localaddr;
	int sock;	

	if((sock=socket(PF_INET,SOCK_STREAM,0))<0)
                randsrc_vexit("socket");
        /* Get a random IPv4 address from the addr.list file and convert it
         * binary data for use with bind().
         */

        line=randsrc_getline("addr.list");
        if(!line)
                randsrc_vexit("getrandline");

        if(randsrc_isdns(line))
        {
                if(!(hostinfo=gethostbyname(line)))
                        randsrc_vexit("gethostbyname");
                memcpy(hostinfo->h_addr_list[0],&(localaddr.s_addr),hostinfo->h_length);
        }
        else
        {
                if(!inet_pton(AF_INET,line,&localaddr))
                        randsrc_vexit("inet_pton");
        }

        local.sin_family=AF_INET;
        local.sin_port=htons(INADDR_ANY);
        local.sin_addr.s_addr=localaddr.s_addr;

        if(bind(sock,(struct sockaddr*)&local,sizeof(local))<0)
                randsrc_vexit("bind");

        remote.sin_family=AF_INET;
        remote.sin_port=htons(port);

        if(!(hostinfo=gethostbyname(host)))
                randsrc_vexit("gethostbyname");

        remote.sin_addr=*(struct in_addr*)hostinfo->h_addr;

        if(connect(sock,(struct sockaddr*)&remote,sizeof(remote))<0)
                randsrc_vexit("connect");

        return sock;
}
